diff -uNr mythtv-0.21/libs/libmythtv/diseqc.cpp mythtv/libs/libmythtv/diseqc.cpp
--- mythtv-0.21/libs/libmythtv/diseqc.cpp	2008-03-08 14:20:46.000000000 +0100
+++ mythtv/libs/libmythtv/diseqc.cpp	2008-11-08 16:36:01.000000000 +0100
@@ -941,7 +941,7 @@
  *  \brief Switch class, including tone, legacy and DiSEqC switches.
  */
 
-const DiSEqCDevDevice::TypeTable DiSEqCDevSwitch::SwitchTypeTable[7] =
+const DiSEqCDevDevice::TypeTable DiSEqCDevSwitch::SwitchTypeTable[9] =
 {
     { "legacy_sw21",  kTypeLegacySW21        },
     { "legacy_sw42",  kTypeLegacySW42        },
@@ -949,7 +949,9 @@
     { "tone",         kTypeTone          },
     { "diseqc",       kTypeDiSEqCCommitted   },
     { "diseqc_uncom", kTypeDiSEqCUncommitted },
-    { QString::null,  kTypeTone          },
+    { "voltage",      kTypeVoltage           },
+    { "mini_diseqc",  kTypeMiniDiSEqC        },
+    { QString::null,  kTypeTone              },
 };
 
 DiSEqCDevSwitch::DiSEqCDevSwitch(DiSEqCDevTree &tree, uint devid)
@@ -1001,6 +1003,12 @@
             case kTypeLegacySW64:
                 success = ExecuteLegacy(settings, tuning, pos);
                 break;
+            case kTypeVoltage:
+                success = ExecuteVoltage(settings, tuning, pos);
+                break;
+            case kTypeMiniDiSEqC:
+                success = ExecuteMiniDiSEqC(settings, tuning, pos);
+                break;
             default:
                 success = false;
                 VERBOSE(VB_IMPORTANT, LOC_ERR +
@@ -1328,6 +1336,56 @@
 }
 
 #ifdef USING_DVB
+static bool set_tone(int fd, fe_sec_tone_mode tone)
+{
+    (void) fd;
+    (void) tone;
+
+    bool success = false;
+
+    for (uint retry = 0; !success && (retry < TIMEOUT_RETRIES); retry++)
+    {
+        if (ioctl(fd, FE_SET_TONE, tone) == 0)
+            success = true;
+        else
+            usleep(TIMEOUT_WAIT);
+    }
+
+    if (!success)
+    {
+        VERBOSE(VB_IMPORTANT, "set_tone failed" + ENO);
+    }
+
+    return success;
+}
+#endif // USING_DVB
+
+#ifdef USING_DVB
+static bool set_voltage(int fd, fe_sec_voltage volt)
+{
+    (void) fd;
+    (void) volt;
+
+    bool success = false;
+
+    for (uint retry = 0; !success && (retry < TIMEOUT_RETRIES); retry++)
+    {
+        if (0 == ioctl(fd, FE_SET_VOLTAGE, volt))
+            success = true;
+        else
+            usleep(TIMEOUT_WAIT);
+    }
+
+    if (!success)
+    {
+        VERBOSE(VB_IMPORTANT, "FE_SET_VOLTAGE failed" + ENO);
+    }
+
+    return success;
+}
+#endif // USING_DVB
+
+#ifdef USING_DVB
 static bool mini_diseqc(int fd, fe_sec_mini_cmd cmd)
 {
     (void) fd;
@@ -1360,7 +1418,7 @@
             QString("%1/2").arg(pos + 1));
 
 #ifdef USING_DVB
-    if (mini_diseqc(m_tree.GetFD(), pos == 0 ? SEC_MINI_A : SEC_MINI_B))
+    if (set_tone(m_tree.GetFD(), (0 == pos) ? SEC_TONE_OFF : SEC_TONE_ON))
         return true;
 #endif // USING_DVB
 
@@ -1368,6 +1426,48 @@
     return false;
 }
 
+bool DiSEqCDevSwitch::ExecuteVoltage(const DiSEqCDevSettings &settings,
+                                     const DTVMultiplex &tuning, uint pos)
+{
+    (void) settings;
+    (void) tuning;
+
+    VERBOSE(VB_CHANNEL, LOC + "Changing to Voltage Switch port " +
+            QString("%1/2").arg(pos + 1));
+
+#ifdef USING_DVB
+    if (set_voltage(m_tree.GetFD(),
+                    (0 == pos) ? SEC_VOLTAGE_13 : SEC_VOLTAGE_18))
+    {
+        return true;
+    }
+#endif // USING_DVB
+
+    VERBOSE(VB_IMPORTANT, LOC_ERR + "Setting Voltage Switch failed." + ENO);
+
+    return false;
+}
+
+bool DiSEqCDevSwitch::ExecuteMiniDiSEqC(const DiSEqCDevSettings &settings,
+                                        const DTVMultiplex &tuning, uint pos)
+{
+    (void) settings;
+    (void) tuning;
+
+    VERBOSE(VB_CHANNEL, LOC + "Changing to MiniDiSEqC Switch port " +
+            QString("%1/2").arg(pos + 1));
+
+#ifdef USING_DVB
+    if (mini_diseqc(m_tree.GetFD(), (0 == pos) ? SEC_MINI_A : SEC_MINI_B))
+        return true;
+#endif // USING_DVB
+
+    VERBOSE(VB_IMPORTANT, LOC_ERR +
+            "Setting Mini DiSEqC Switch failed." + ENO);
+
+    return false;
+}
+
 bool DiSEqCDevSwitch::ShouldSwitch(const DiSEqCDevSettings &settings,
                                    const DTVMultiplex &tuning) const
 {
@@ -1404,6 +1504,8 @@
         if (horizontal != m_last_horizontal)
             return true;
     }
+    else if (kTypeTone == m_type)
+        return true;
 
     return m_last_pos != (uint)pos;
 }
diff -uNr mythtv-0.21/libs/libmythtv/diseqc.h mythtv/libs/libmythtv/diseqc.h
--- mythtv-0.21/libs/libmythtv/diseqc.h	2006-12-13 16:49:12.000000000 +0100
+++ mythtv/libs/libmythtv/diseqc.h	2008-11-08 16:36:01.000000000 +0100
@@ -224,6 +224,8 @@
         kTypeLegacySW21        = 3,
         kTypeLegacySW42        = 4,
         kTypeLegacySW64        = 5,
+        kTypeVoltage           = 6,
+        kTypeMiniDiSEqC        = 7,
     };
     void SetType(dvbdev_switch_t type)        { m_type = type;      }
     void SetNumPorts(uint num_ports);
@@ -252,9 +254,16 @@
 
 
   protected:
-    bool ExecuteLegacy(const DiSEqCDevSettings&, const DTVMultiplex&, uint pos);
-    bool ExecuteTone(  const DiSEqCDevSettings&, const DTVMultiplex&, uint pos);
-    bool ExecuteDiseqc(const DiSEqCDevSettings&, const DTVMultiplex&, uint pos);
+    bool ExecuteLegacy(
+        const DiSEqCDevSettings&, const DTVMultiplex&, uint pos);
+    bool ExecuteTone(
+        const DiSEqCDevSettings&, const DTVMultiplex&, uint pos);
+    bool ExecuteVoltage(
+        const DiSEqCDevSettings&, const DTVMultiplex&, uint pos);
+    bool ExecuteMiniDiSEqC(
+        const DiSEqCDevSettings&, const DTVMultiplex&, uint pos);
+    bool ExecuteDiseqc(
+        const DiSEqCDevSettings&, const DTVMultiplex&, uint pos);
 
     int  GetPosition(  const DiSEqCDevSettings&) const;
 
@@ -266,7 +275,7 @@
     uint            m_last_horizontal;
     dvbdev_vec_t    m_children;
 
-    static const TypeTable SwitchTypeTable[7];
+    static const TypeTable SwitchTypeTable[9];
 };
 
 class DiSEqCDevRotor : public DiSEqCDevDevice
diff -uNr mythtv-0.21/libs/libmythtv/diseqcsettings.cpp mythtv/libs/libmythtv/diseqcsettings.cpp
--- mythtv-0.21/libs/libmythtv/diseqcsettings.cpp	2007-11-19 17:44:58.000000000 +0100
+++ mythtv/libs/libmythtv/diseqcsettings.cpp	2008-11-08 16:36:01.000000000 +0100
@@ -147,6 +147,10 @@
 
         addSelection(DeviceTree::tr("Tone"),
                      QString::number((uint) DiSEqCDevSwitch::kTypeTone));
+        addSelection(DeviceTree::tr("Voltage"),
+                     QString::number((uint) DiSEqCDevSwitch::kTypeVoltage));
+        addSelection(DeviceTree::tr("Mini DiSEqC"),
+                     QString::number((uint) DiSEqCDevSwitch::kTypeMiniDiSEqC));
         addSelection(DeviceTree::tr("DiSEqC"),
                      QString::number((uint)
                                      DiSEqCDevSwitch::kTypeDiSEqCCommitted));
@@ -232,6 +236,8 @@
     switch ((DiSEqCDevSwitch::dvbdev_switch_t) m_type->getValue().toUInt())
     {
         case DiSEqCDevSwitch::kTypeTone:
+        case DiSEqCDevSwitch::kTypeVoltage:
+        case DiSEqCDevSwitch::kTypeMiniDiSEqC:
         case DiSEqCDevSwitch::kTypeLegacySW21:
         case DiSEqCDevSwitch::kTypeLegacySW42:
             m_ports->setValue("2");
diff -uNr mythtv-0.21/libs/libmythtv/dtvrecorder.cpp mythtv/libs/libmythtv/dtvrecorder.cpp
--- mythtv-0.21/libs/libmythtv/dtvrecorder.cpp	2008-02-18 17:01:43.000000000 +0100
+++ mythtv/libs/libmythtv/dtvrecorder.cpp	2008-10-02 19:29:55.000000000 +0200
@@ -20,7 +20,7 @@
 #define LOC QString("DTVRec(%1): ").arg(tvrec->GetCaptureCardNum())
 #define LOC_ERR QString("DTVRec(%1) Error: ").arg(tvrec->GetCaptureCardNum())
 
-const uint DTVRecorder::kMaxKeyFrameDistance = 32;
+const uint DTVRecorder::kMaxKeyFrameDistance = 80;
 
 /** \class DTVRecorder
  *  \brief This is a specialization of RecorderBase used to
diff -uNr mythtv-0.21/libs/libmythtv/dvbtypes.h mythtv/libs/libmythtv/dvbtypes.h
--- mythtv-0.21/libs/libmythtv/dvbtypes.h	2007-01-07 16:29:30.000000000 +0100
+++ mythtv/libs/libmythtv/dvbtypes.h	2009-01-30 23:55:19.000000000 +0100
@@ -19,7 +19,7 @@
 #include <linux/dvb/frontend.h>
 #include <linux/dvb/dmx.h>
 
-#if (DVB_API_VERSION != 3)
+#if (DVB_API_VERSION != 3 && DVB_API_VERSION != 5)
 #    error "DVB driver includes with API version 3 not found!"
 #endif
 
@@ -27,7 +27,7 @@
 #    define DVB_API_VERSION_MINOR 0
 #endif
 
-#if (DVB_API_VERSION >= 3 && DVB_API_VERSION_MINOR >= 1)
+#if ((DVB_API_VERSION == 3 && DVB_API_VERSION_MINOR >= 1) || (DVB_API_VERSION > 3))
 #    define USE_ATSC
 #else
 #warning DVB API version < 3.1
diff -uNr mythtv-0.21/libs/libmythtv/DVDRingBuffer.cpp mythtv/libs/libmythtv/DVDRingBuffer.cpp
--- mythtv-0.21/libs/libmythtv/DVDRingBuffer.cpp	2008-03-08 22:05:09.000000000 +0100
+++ mythtv/libs/libmythtv/DVDRingBuffer.cpp	2008-11-05 02:40:32.000000000 +0100
@@ -29,21 +29,24 @@
       dvdFilename(NULL),
       dvdBlockRPos(0),  dvdBlockWPos(0),
       pgLength(0),      pgcLength(0),
-      cellStart(0),     pgStart(0),
+      cellStart(0),     cellChanged(false),
+      pgcLengthChanged(false), pgStart(0),
       currentpos(0),
       lastNav(NULL),    part(0),
       title(0),         titleParts(0),
       gotStop(false),
-      cellHasStillFrame(false), dvdWaiting(false),
-      titleLength(0), hl_startx(0), hl_width(0),
-      hl_starty(0), hl_height(0),
+      cellHasStillFrame(false), audioStreamsChanged(false),
+      dvdWaiting(false),
+      titleLength(0), hl_button(0, 0, 0, 0),
+      menuSpuPkt(0),
       menuBuflength(0),
       skipstillorwait(true),
       cellstartPos(0), buttonSelected(false), 
       buttonExists(false), cellid(0), 
       lastcellid(0), vobid(0), 
       lastvobid(0), cellRepeated(false), 
-      buttonstreamid(0), gotoCellStart(false), 
+      buttonstreamid(0), runningCellStart(false), 
+      runSeekCellStart(false),
       menupktpts(0), curAudioTrack(0),
       curSubtitleTrack(0), autoselectaudio(true),
       autoselectsubtitle(true), 
@@ -55,6 +58,10 @@
       parent(0)
 {
     memset(&dvdMenuButton, 0, sizeof(AVSubtitle));
+    memset(dvdBlockWriteBuf, 0, sizeof(char) * DVD_BLOCK_SIZE);
+    memset(clut, 0, sizeof(uint32_t) * 16);
+    memset(button_color, 0, sizeof(uint8_t) * 4);
+    memset(button_alpha, 0, sizeof(uint8_t) * 4);
     uint def[8] = { 3, 5, 10, 20, 30, 60, 120, 180 };
     uint seekValues[8] = { 1, 2, 4, 8, 10, 15, 20, 60 };
 
@@ -80,9 +87,9 @@
 
 bool DVDRingBufferPriv::IsInMenu(void) const
 {
-    return ((title == 0) || 
-            ((pgcLength/90000) < 30) ||
-            (NumMenuButtons() > 0));
+    if (dvdnav)
+        return (!dvdnav_is_domain_vts(dvdnav));
+    return true;
 }
 
 long long DVDRingBufferPriv::NormalSeek(long long time)
@@ -119,8 +126,9 @@
     {
         VERBOSE(VB_PLAYBACK, LOC_ERR + 
                 QString("Seek() to time %1 failed").arg(time));
+        return -1;
     }
-    else if (!IsInMenu() && !gotoCellStart)
+    else if (!IsInMenu() && !runningCellStart)
     {
         gotStop = false;
         if (time > 0 && ffrewSkip == 1)
@@ -274,9 +282,12 @@
                 dvdnav_cell_change_event_t *cell_event =
                     (dvdnav_cell_change_event_t*) (blockBuf);
                 pgLength  = cell_event->pg_length;
+                if (pgcLength != cell_event->pgc_length)
+                    pgcLengthChanged = true;
                 pgcLength = cell_event->pgc_length;
                 cellStart = cell_event->cell_start;
                 pgStart   = cell_event->pg_start;
+                cellChanged = true;
 
                 if (dvdnav_get_next_still_flag(dvdnav) > 0)
                 {
@@ -306,10 +317,10 @@
                             .arg(title).arg(part).arg(titleParts));
 
                 buttonSelected = false;
-                if (gotoCellStart)
+                if (runningCellStart)
                 {
                     lastvobid = lastcellid = 0;
-                    gotoCellStart = false;
+                    runningCellStart = false;
                 }
                 else
                 {
@@ -355,7 +366,10 @@
                 subTrackMap.clear();
                 uint count = dvdnav_subp_get_stream_count(dvdnav);
 
-                ClearMenuSPUParameters();
+                //ClearMenuSPUParameters();
+                if (parent)
+                    parent->HideDVDButton(true);
+
                 ClearSubtitlesOSD();
 
                 if (IsInMenu())
@@ -446,6 +460,8 @@
                             break;
                     }
                 }
+                
+                audioStreamsChanged = true;
 
                 if (blockBuf != dvdBlockWriteBuf)
                 {
@@ -536,18 +552,13 @@
                         .arg(hl->pts).arg(hl->buttonN));
 
                 menuBtnLock.lock();
-
-                if (DVDButtonUpdate(false))
-                {
-                    ClearMenuButton();
-                    buttonExists = DrawMenuButton(menuSpuPkt,menuBuflength);
-                }
-
-                menuBtnLock.unlock();
-
+                
+                DVDButtonUpdate(false);
                 ClearSubtitlesOSD();
-
-                if (parent && buttonExists && NumMenuButtons() > 0)
+                
+                menuBtnLock.unlock();
+                
+                if (parent && buttonExists)
                     parent->HideDVDButton(false);
 
                 if (blockBuf != dvdBlockWriteBuf)
@@ -656,6 +667,24 @@
     return cellStart / 90000;
 }
 
+/** \brief check if dvd cell has changed
+ */
+bool DVDRingBufferPriv::CellChanged(void)
+{
+    bool ret = cellChanged;
+    cellChanged = false;
+    return ret;
+}
+
+/** \brief check if pgc length has changed
+ */
+bool DVDRingBufferPriv::PGCLengthChanged(void)
+{
+    bool ret = pgcLengthChanged;
+    pgcLengthChanged = false;
+    return ret;
+}
+
 void DVDRingBufferPriv::SkipStillFrame(void)
 {
     QMutexLocker locker(&seekLock);
@@ -687,12 +716,16 @@
     }
     else if (str.compare("menu") == 0)
     {
+        dvdnav_status_t rootMenuSupported =
+            dvdnav_menu_supported(dvdnav, DVD_MENU_Root);
         dvdnav_status_t titleMenuSupported =
             dvdnav_menu_supported(dvdnav, DVD_MENU_Title);
-        if (titleMenuSupported == DVDNAV_STATUS_OK)
+        if (rootMenuSupported == DVDNAV_STATUS_OK)
+            menuid = DVD_MENU_Root;
+        else if (titleMenuSupported == DVDNAV_STATUS_OK)
             menuid = DVD_MENU_Title;
         else
-            menuid = DVD_MENU_Root;
+            return false;
     }
     else
         return false;
@@ -720,7 +753,7 @@
 
 void DVDRingBufferPriv::MoveButtonLeft(void)
 {
-    if (IsInMenu() && (NumMenuButtons() > 0))
+    if (NumMenuButtons() > 1)
     {
         pci_t *pci = dvdnav_get_current_nav_pci(dvdnav);
         dvdnav_left_button_select(dvdnav, pci);
@@ -729,7 +762,7 @@
 
 void DVDRingBufferPriv::MoveButtonRight(void)
 {
-    if (IsInMenu() && (NumMenuButtons() > 0) )
+    if (NumMenuButtons() > 1)
     {
         pci_t *pci = dvdnav_get_current_nav_pci(dvdnav);
         dvdnav_right_button_select(dvdnav, pci);
@@ -738,7 +771,7 @@
 
 void DVDRingBufferPriv::MoveButtonUp(void)
 {
-    if (IsInMenu() && (NumMenuButtons() > 0))
+    if (NumMenuButtons() > 1)
     {
         pci_t *pci = dvdnav_get_current_nav_pci(dvdnav);
         dvdnav_upper_button_select(dvdnav, pci);
@@ -747,7 +780,7 @@
 
 void DVDRingBufferPriv::MoveButtonDown(void)
 {
-    if (IsInMenu() && (NumMenuButtons() > 0))
+    if (NumMenuButtons() > 1)
     {
         pci_t *pci = dvdnav_get_current_nav_pci(dvdnav);
         dvdnav_lower_button_select(dvdnav, pci);
@@ -758,7 +791,7 @@
  */
 void DVDRingBufferPriv::ActivateButton(void)
 {
-    if (IsInMenu() && (NumMenuButtons() > 0))
+    if (NumMenuButtons() > 0)
     {
         pci_t *pci = dvdnav_get_current_nav_pci(dvdnav);
         dvdnav_button_activate(dvdnav, pci);
@@ -788,22 +821,27 @@
         SelectDefaultButton();
         buttonSelected = true;
     }
+
     if (DVDButtonUpdate(false))
-        buttonExists = DrawMenuButton(menuSpuPkt,menuBuflength);
+    {
+        int32_t gotbutton;
+        buttonExists = DecodeSubtitles(&dvdMenuButton, &gotbutton, 
+                                        menuSpuPkt, menuBuflength);
+    }
 }
 
-/** \brief returns dvd menu button if available.
+/** \brief returns dvd menu button information if available.
  * used by NVP::DisplayDVDButton
  */
-AVSubtitleRect *DVDRingBufferPriv::GetMenuButton(void)
+AVSubtitle *DVDRingBufferPriv::GetMenuSubtitle(void)
 {
     menuBtnLock.lock();
 
     if ((menuBuflength > 4) && buttonExists &&
-        (dvdMenuButton.rects[0].h >= hl_height) && 
-        (dvdMenuButton.rects[0].w >= hl_width))
+        (dvdMenuButton.rects[0].h >= hl_button.height()) && 
+        (dvdMenuButton.rects[0].w >= hl_button.width()))
     {
-        return &(dvdMenuButton.rects[0]);
+        return &(dvdMenuButton);
     }
 
     return NULL;
@@ -815,27 +853,25 @@
     menuBtnLock.unlock();
 }
 
-/** \brief obtain dvd menu button bitmap, alpha and color palette
+/** \brief get coordinates of highlighted button
  */
-bool DVDRingBufferPriv::DrawMenuButton(uint8_t *spu_pkt, int buf_size)
+QRect DVDRingBufferPriv::GetButtonCoords(void)
 {
-    int gotbutton;
-    if (DecodeSubtitles(&dvdMenuButton, &gotbutton, spu_pkt, buf_size))
-    {
-        int x1, y1;
-        x1 = dvdMenuButton.rects[0].x;
-        y1 = dvdMenuButton.rects[0].y;
-        if (hl_startx > x1)
-            dvdMenuButton.rects[0].x = hl_startx - x1;
-        else
-            dvdMenuButton.rects[0].x = 0;
-        if (hl_starty > y1)
-            dvdMenuButton.rects[0].y  = hl_starty - y1;
-        else
-            dvdMenuButton.rects[0].y = 0;
-        return true;
-    }
-    return false;
+    QRect rect(0,0,0,0);
+    if (!buttonExists)
+        return rect;
+
+    int x1, y1;
+    int x = 0; int y = 0;
+    x1 = dvdMenuButton.rects[0].x;
+    y1 = dvdMenuButton.rects[0].y;
+    if (hl_button.x() > x1)
+        x = hl_button.x() - x1;
+    if (hl_button.y() > y1)
+        y  = hl_button.y() - y1;
+    rect.setRect(x, y, hl_button.width(), hl_button.height());    
+    
+    return rect;
 }
 
 /** \brief generate dvd subtitle bitmap or dvd menu bitmap. 
@@ -891,13 +927,11 @@
                 {
                     if ((buf_size - pos) < 2)
                         goto fail;
-                    if (!IsInMenu())
-                    {
-                        palette[3] = spu_pkt[pos] >> 4;
-                        palette[2] = spu_pkt[pos] & 0x0f;
-                        palette[1] = spu_pkt[pos + 1] >> 4;
-                        palette[0] = spu_pkt[pos + 1] & 0x0f;
-                    }
+                    
+                    palette[3] = spu_pkt[pos] >> 4;
+                    palette[2] = spu_pkt[pos] & 0x0f;
+                    palette[1] = spu_pkt[pos + 1] >> 4;
+                    palette[0] = spu_pkt[pos + 1] & 0x0f;
                     pos +=2;
                 }
                 break;
@@ -905,13 +939,10 @@
                 {
                     if ((buf_size - pos) < 2)
                         goto fail;
-                    if (!IsInMenu())
-                    {
-                        alpha[3] = spu_pkt[pos] >> 4;
-                        alpha[2] = spu_pkt[pos] & 0x0f;
-                        alpha[1] = spu_pkt[pos + 1] >> 4;
-                        alpha[0] = spu_pkt[pos + 1] & 0x0f;
-                    }
+                    alpha[3] = spu_pkt[pos] >> 4;
+                    alpha[2] = spu_pkt[pos] & 0x0f;
+                    alpha[1] = spu_pkt[pos + 1] >> 4;
+                    alpha[0] = spu_pkt[pos + 1] & 0x0f;
                     pos +=2;
                 }
                 break;
@@ -948,19 +979,11 @@
             w = x2 - x1 + 1;
             if (w < 0)
                 w = 0;
-            h = y2 - y1;
+            h = y2 - y1 + 2;
             if (h < 0)
                 h = 0;
             if (w > 0 && h > 0) 
             {
-                if (IsInMenu())
-                {
-                    for (int i = 0; i < 4 ; i++)
-                    {
-                        alpha[i]   = button_alpha[i];
-                        palette[i] = button_color[i];
-                    }
-                }
                 if (sub->rects != NULL)
                 {
                     for (i = 0; i < sub->num_rects; i++)
@@ -973,8 +996,9 @@
                 }
 
                 bitmap = (uint8_t*) av_malloc(w * h);
-                sub->rects = (AVSubtitleRect *)av_mallocz(sizeof(AVSubtitleRect));
-                sub->num_rects = 1;
+                sub->num_rects = (NumMenuButtons() > 0) ? 2 : 1;
+                sub->rects = (AVSubtitleRect *)
+                        av_mallocz(sizeof(AVSubtitleRect) * sub->num_rects);
                 sub->rects[0].rgba_palette = (uint32_t*)av_malloc(4 *4);
                 decode_rle(bitmap, w * 2, w, (h + 1) / 2,
                             spu_pkt, offset1 * 2, buf_size);
@@ -988,7 +1012,13 @@
                 sub->rects[0].h = h;
                 sub->rects[0].nb_colors = 4;
                 sub->rects[0].linesize = w;
-                if (!IsInMenu())
+                if (NumMenuButtons() > 0)
+                {
+                    sub->rects[1].rgba_palette = (uint32_t*)av_malloc(4 *4);
+                    guess_palette(sub->rects[1].rgba_palette, 
+                                button_color, button_alpha);
+                }
+                else
                     find_smallest_bounding_rectangle(sub);
                 *gotSubtitles = 1;
             }
@@ -1003,9 +1033,9 @@
         {
             uint captionmode = parent->GetCaptionMode();
             if (force_subtitle_display && captionmode != kDisplayAVSubtitle)
-                parent->SetCaptionsEnabled(true, false);
+                parent->EnableCaptions(kDisplayAVSubtitle, false);
             else if (!force_subtitle_display && captionmode == kDisplayAVSubtitle)
-                parent->SetCaptionsEnabled(false, false);
+                parent->DisableCaptions(kDisplayAVSubtitle, false);
         }
         return true;
     }
@@ -1036,27 +1066,13 @@
     if (dvdRet == DVDNAV_STATUS_ERR)
         return false;
 
-    bool button_is_transparent = true;
-
     for (uint i = 0 ; i < 4 ; i++)
     {
         button_alpha[i] = 0xf & (hl.palette >> (4 * i ));
-        if (button_alpha[i] > 0)
-            button_is_transparent = false;
         button_color[i] = 0xf & (hl.palette >> (16+4 *i ));
     }
 
-    if (button_is_transparent)
-    {
-        for (uint i = 0; i < 4; i++)
-            button_alpha[i] = 10;
-    }
-
-
-    hl_startx = hl.sx;
-    hl_width = hl.ex - hl.sx;
-    hl_starty = hl.sy;
-    hl_height  = hl.ey - hl.sy;
+    hl_button.setCoords(hl.sx, hl.sy, hl.ex, hl.ey);
 
     if (((hl.sx + hl.sy) > 0) && 
             (hl.sx < videowidth && hl.sy < videoheight))
@@ -1071,10 +1087,13 @@
 {
     if (buttonExists || dvdMenuButton.rects)
     {
-        av_free(dvdMenuButton.rects[0].rgba_palette);
-        av_free(dvdMenuButton.rects[0].bitmap);
+        for (uint i = 0; i < dvdMenuButton.num_rects; i++)
+        {
+            AVSubtitleRect* rect =  &(dvdMenuButton.rects[i]);
+            av_free(rect->rgba_palette);
+            av_free(rect->bitmap);
+        }
         av_free(dvdMenuButton.rects);
-
         dvdMenuButton.rects = NULL;
         dvdMenuButton.num_rects = 0;
         buttonExists = false;
@@ -1095,8 +1114,7 @@
 
     av_free(menuSpuPkt);
     menuBuflength = 0;
-    hl_startx = hl_starty = 0;
-    hl_width = hl_height = 0;
+    hl_button.setRect(0, 0, 0, 0);
 }
 
 int DVDRingBufferPriv::NumMenuButtons(void) const
@@ -1289,13 +1307,33 @@
     return false;
 }
 
+/** \brief Run SeekCellStart its okay to run seekcellstart
+ ** ffmpeg for some reason doesnt' output menu spu if seekcellstart
+ ** is started too soon after a video codec/resolution change
+ */
+void DVDRingBufferPriv::RunSeekCellStart(void)
+{
+    if (!runSeekCellStart)
+        return;
+    
+    bool ret = true;
+    if (NumMenuButtons() > 0 && !buttonExists)
+        ret = false;
+    
+    if (ret) 
+    {
+        ret = SeekCellStart();
+        runSeekCellStart = false;
+    }
+}
+
 /** \brief seek the beginning of a dvd cell
  */
-void DVDRingBufferPriv::SeekCellStart(void)
+bool DVDRingBufferPriv::SeekCellStart(void)
 {
     QMutexLocker lock(&seekLock);
-    gotoCellStart = true;
-    Seek(cellStart);
+    runningCellStart = true;
+    return (Seek(cellStart) == 0);
 }
 
 /** \brief set dvd speed. uses the DVDDriveSpeed Setting from the settings 
diff -uNr mythtv-0.21/libs/libmythtv/DVDRingBuffer.h mythtv/libs/libmythtv/DVDRingBuffer.h
--- mythtv-0.21/libs/libmythtv/DVDRingBuffer.h	2007-09-06 18:56:45.000000000 +0200
+++ mythtv/libs/libmythtv/DVDRingBuffer.h	2008-05-12 05:08:03.000000000 +0200
@@ -41,21 +41,21 @@
     void GetPartAndTitle(int &_part, int &_title) const
         { _part  = part; _title = title; }
     uint GetTotalTimeOfTitle(void);
-    uint GetChapterLength(void) { return pgLength / 90000; }
+    uint GetChapterLength(void) const { return pgLength / 90000; }
     uint GetCellStart(void);
-    bool InStillFrame(void) { return cellHasStillFrame; }
-    bool IsWaiting(void) { return dvdWaiting; }
-    int  NumPartsInTitle(void) { return titleParts; }
+    bool PGCLengthChanged(void);
+    bool CellChanged(void);
+    bool InStillFrame(void) const { return cellHasStillFrame; }
+    bool AudioStreamsChanged(void) const { return audioStreamsChanged; }
+    bool IsWaiting(void) const { return dvdWaiting; }
+    int  NumPartsInTitle(void) const { return titleParts; }
     void GetMenuSPUPkt(uint8_t *buf, int len, int stream_id);
 
-    AVSubtitleRect *GetMenuButton(void);
+    QRect GetButtonCoords(void);
+    AVSubtitle *GetMenuSubtitle(void);
     void ReleaseMenuButton(void);
 
     bool IgnoringStillorWait(void) { return skipstillorwait; }
-    uint ButtonPosX(void)   { return hl_startx; }
-    uint ButtonPosY(void)   { return hl_starty; }
-    uint ButtonWidth(void)  { return hl_width; }
-    uint ButtonHeight(void) { return hl_height; }
     uint GetAudioLanguage(int id);
     int  GetSubTrackNum(uint key);
     int  GetAudioTrackNum(uint key);
@@ -74,6 +74,7 @@
     int GetCellID(void) { return cellid; }
     int GetVobID(void)  { return vobid; }
     bool IsSameChapter(int tmpcellid, int tmpvobid);
+    void RunSeekCellStart(void);
 
     // commands
     bool OpenFile(const QString &filename);
@@ -97,15 +98,16 @@
     int NumMenuButtons(void) const;
     void IgnoreStillOrWait(bool skip) { skipstillorwait = skip; }
     void InStillFrame(bool change) { cellHasStillFrame = change; }
+    void AudioStreamsChanged(bool change) { audioStreamsChanged = change; }
     uint GetCurrentTime(void) { return (currentTime / 90000); }
     uint TitleTimeLeft(void);
     void  SetTrack(uint type, int trackNo);
     int   GetTrack(uint type);
     uint8_t GetNumAudioChannels(int id);
     void JumpToTitle(bool change) { jumptotitle = change; }
-    void SeekCellStart(void);
     void SetDVDSpeed(void);
     void SetDVDSpeed(int speed);
+    void SetRunSeekCellStart(bool change) { runSeekCellStart = change; }
 
     void SetParent(NuppelVideoPlayer *p) { parent = p; }
 
@@ -120,6 +122,8 @@
     long long      pgLength;
     long long      pgcLength;
     long long      cellStart;
+    bool           cellChanged;
+    bool           pgcLengthChanged;
     long long      pgStart;
     long long      currentpos;
     dvdnav_t      *lastNav; // This really belongs in the player.
@@ -129,19 +133,16 @@
     bool           gotStop;
 
     bool           cellHasStillFrame;
+    bool           audioStreamsChanged;
     bool           dvdWaiting;
     long long      titleLength;
     MythTimer      stillFrameTimer;
     uint32_t       clut[16];
     uint8_t        button_color[4];
     uint8_t        button_alpha[4];
-    uint16_t       hl_startx;
-    uint16_t       hl_width;
-    uint16_t       hl_starty;
-    uint16_t       hl_height;
+    QRect          hl_button;
     uint8_t       *menuSpuPkt;
     int            menuBuflength;
-    uint8_t       *buttonBitmap;
     AVSubtitle     dvdMenuButton;
     bool           skipstillorwait;
     long long      cellstartPos;
@@ -153,7 +154,8 @@
     int            lastvobid;
     bool           cellRepeated;
     int            buttonstreamid;
-    bool           gotoCellStart;
+    bool           runningCellStart;
+    bool           runSeekCellStart;
     long long      menupktpts;
     int            curAudioTrack;
     int8_t         curSubtitleTrack;
@@ -177,7 +179,6 @@
     QMutex seekLock;
 
     long long Seek(long long time);
-    bool DrawMenuButton(uint8_t *spu_pkt, int buf_size);
     bool DVDButtonUpdate(bool b_mode);
     void ClearMenuSPUParameters(void);
     void ClearMenuButton(void);
@@ -185,6 +186,7 @@
     uint ConvertLangCode(uint16_t code);
     void SelectDefaultButton(void);
     void ClearSubtitlesOSD(void);
+    bool SeekCellStart(void);
 
     int get_nibble(const uint8_t *buf, int nibble_offset);
     int decode_rle(uint8_t *bitmap, int linesize, int w, int h,
diff -uNr mythtv-0.21/libs/libmythtv/eit.cpp mythtv/libs/libmythtv/eit.cpp
--- mythtv-0.21/libs/libmythtv/eit.cpp	2008-03-06 23:44:40.000000000 +0100
+++ mythtv/libs/libmythtv/eit.cpp	2009-05-05 02:10:59.000000000 +0200
@@ -239,7 +239,7 @@
     }
     score /= al.size();
 
-    return max(1000, score);
+    return min(1000, score);
 }
 
 int DBEvent::GetMatch(const vector<DBEvent> &programs, int &bestmatch) const
diff -uNr mythtv-0.21/libs/libmythtv/eitfixup.h mythtv/libs/libmythtv/eitfixup.h
--- mythtv-0.21/libs/libmythtv/eitfixup.h	2008-02-14 13:27:49.000000000 +0100
+++ mythtv/libs/libmythtv/eitfixup.h	2009-05-05 21:57:19.000000000 +0200
@@ -55,12 +55,16 @@
 
     void Fix(DBEvent &event) const;
 
+    /** Corrects starttime to the multiple of a minute. 
+     *  Used for providers who fail to handle leap seconds timely. Changes the
+     *  starttime not more than 3 seconds. Sshould only be used if the
+     *  duration is the multiple of a minute. */
     static void TimeFix(QDateTime &dt)
     {
         int secs = dt.time().second();
-        if (secs < 5)
+        if (secs < 4)
             dt = dt.addSecs(-secs);
-        if (secs > 55)
+        if (secs > 56)
             dt = dt.addSecs(60 - secs);
     }
 
